/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.43 Revision 1.56
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.43 2006/10/23 12:26:45 vivo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.56 2007/01/04 10:32:38 vivo Exp $
4# kate: encoding utf-8; eol unix;
5# kate: indent-width 4; mixedindent off; remove-trailing-space on; space-indent off;
6# kate: word-wrap-column 80; word-wrap off;
4 7
5# Author: Francesco Riosa <vivo@gentoo.org> 8# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: Luca Longinotti <chtekk@gentoo.org> 9# Maintainer: Luca Longinotti <chtekk@gentoo.org>
7 10
8# Both MYSQL_VERSION_ID and MYSQL_PATCHSET_REV must be set in the ebuild too
9# Note that MYSQL_VERSION_ID must be empty !!! 11# Note that MYSQL_VERSION_ID must be empty !!!
10 12
13ECLASS="mysql"
14INHERITED="$INHERITED $ECLASS"
15inherit eutils flag-o-matic gnuconfig autotools mysql_fx
16
17# avoid running userspace code 8 times per ebuild :(
18if [[ "${_MYPVR}" != "${PVR}" ]] && [[ -n "${PVR}" ]]
19then
20 _MYPVR=${PVR}
21
22 [[ -z ${MY_EXTRAS_VER} ]] && MY_EXTRAS_VER="20070103"
23
24 if [[ ${PR#r} -lt 60 ]] ; then
25 IS_BITKEEPER=0
26 elif [[ ${PR#r} -lt 90 ]] ; then
27 IS_BITKEEPER=60
28 else
29 IS_BITKEEPER=90
30 fi
31
11# MYSQL_VERSION_ID will be: 32 # MYSQL_VERSION_ID will be:
12# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 33 # major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
13# This is an important part, because many of the choices the MySQL ebuild will do 34 # This is an important part, because many of the choices the MySQL ebuild will do
14# depend on this variable. 35 # depend on this variable.
15# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 36 # In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
16 37 MYSQL_VERSION_ID=""
17if [[ -z "${MYSQL_VERSION_ID}" ]] ; then
18 tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}" 38 tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
19 for vatom in 0 1 2 3 ; do 39 for vatom in 0 1 2 3 ; do
20 # pad to length 2 40 # pad to length 2
21 tpv[${vatom}]="00${tpv[${vatom}]}" 41 tpv[${vatom}]="00${tpv[${vatom}]}"
22 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}" 42 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
23 done 43 done
24 # strip leading "0" (otherwise it's considered an octal number by BASH) 44 # strip leading "0" (otherwise it's considered an octal number by BASH)
25 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 45 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
26fi
27 46
28inherit eutils flag-o-matic gnuconfig autotools mysql_fx
29
30# Be warned, *DEPEND are version-dependant 47 # Be warned, *DEPEND are version-dependant
31DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d ) 48 DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
32 userland_GNU? ( sys-process/procps ) 49 userland_GNU? ( sys-process/procps )
33 >=sys-apps/sed-4 50 >=sys-apps/sed-4
34 >=sys-apps/texinfo-4.7-r1 51 >=sys-apps/texinfo-4.7-r1
35 >=sys-libs/readline-4.1 52 >=sys-libs/readline-4.1
36 >=sys-libs/zlib-1.2.3" 53 >=sys-libs/zlib-1.2.3"
37 54
55 # having different flavours at the same time is not a good idea
56 for i in "" "-community" "-slotted" ; do
57 [[ "${i}" == ${PN#mysql} ]] ||
58 DEPEND="${DEPEND} !dev-db/mysql${i}"
59 done
60
38mysql_version_is_at_least "5.01.00.00" \ 61 mysql_version_is_at_least "5.1" \
39|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 62 || DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
40 63
41RDEPEND="${DEPEND} selinux? ( sec-policy/selinux-mysql )"
42
43# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 64 # dev-perl/DBD-mysql is needed by some scripts installed by MySQL
44PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 65 PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
45 66
67 if mysql_version_is_at_least "5.1.12" ; then
68 DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )"
69 fi
70
46# Shorten the path because the socket path length must be shorter than 107 chars 71 # Shorten the path because the socket path length must be shorter than 107 chars
47# and we will run a mysql server during test phase 72 # and we will run a mysql server during test phase
48S="${WORKDIR}/${PN/_alpha/-bk-}" # BitKeeper ebuilds 73 S="${WORKDIR}/mysql"
49 74
50# Define $MY_FIXED_PV for MySQL patchsets 75 # BitKeeper dependency, compile-time only
51MY_FIXED_PV="${PV/_alpha/}" 76 [[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client"
52#MY_FIXED_PV="${MY_FIXED_PV/_beta/}"
53#MY_FIXED_PV="${MY_FIXED_PV/_rc/}"
54 77
55MY_P="${P/_/-}" 78 if [[ ${PN} == "mysql-slotted" ]] ; then
56MY_P="${MY_P/-alpha/-bk-}" # BitKeeper ebuilds 79 DEPEND="${DEPEND} app-admin/eselect-mysql"
80 fi
57 81
82 if [[ ${PN} == "mysql-slotted" ]] ; then
83 SLOT=""
84 tpv=( ${PV//[-._]/ } )
85 for vatom in 0 1 2 ; do
86 SLOT="${SLOT}${tpv[${vatom}]}_"
87 done
88 #finally SLOT=5_0_24
89 SLOT=${SLOT:0:${#SLOT}-1}
90 else
91 SLOT="0"
92 fi
93
58# Define correct SRC_URIs 94 # Define correct SRC_URIs
59SRC_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/${MY_P}${MYSQL_RERELEASE}.tar.gz" 95 SRC_URI="
60if [[ -n "${MYSQL_PATCHSET_REV}" ]] ; then 96 ${SERVER_URI}
61 MYSQL_PATCHSET_FILENAME="${PN}-patchset-${MY_FIXED_PV}-r${MYSQL_PATCHSET_REV}.tar.bz2" 97 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
62 # We add the Gentoo mirror here, as we only use primaryuri for the MySQL tarball 98 "
63 SRC_URI="${SRC_URI} http://gentoo.longitekk.com/${MYSQL_PATCHSET_FILENAME}" 99 mysql_version_is_at_least "5.1.12" \
64fi 100 && [[ -n "${PBXT_VERSION}" ]] \
101 && SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
65 102
66DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 103 DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
67HOMEPAGE="http://www.mysql.com/" 104 HOMEPAGE="http://www.mysql.com/"
68SLOT="0"
69LICENSE="GPL-2" 105 LICENSE="GPL-2"
70IUSE="big-tables debug embedded minimal perl selinux srvdir ssl static" 106 IUSE="big-tables debug embedded minimal perl selinux ssl static"
71RESTRICT="confcache" 107 RESTRICT="confcache"
72 108
73mysql_version_is_at_least "4.01.00.00" \ 109 mysql_version_is_at_least "4.1" \
74&& IUSE="${IUSE} latin1" 110 && IUSE="${IUSE} latin1"
75 111
76mysql_version_is_at_least "4.01.03.00" \ 112 mysql_version_is_at_least "4.1.3" \
77&& IUSE="${IUSE} cluster extraengine" 113 && IUSE="${IUSE} cluster extraengine"
78 114
79mysql_version_is_at_least "5.00.00.00" \ 115 mysql_version_is_at_least "5.0" \
80|| IUSE="${IUSE} raid" 116 || IUSE="${IUSE} raid"
81 117
82mysql_version_is_at_least "5.00.18.00" \ 118 mysql_version_is_at_least "5.0.18" \
83&& IUSE="${IUSE} max-idx-128" 119 && IUSE="${IUSE} max-idx-128"
84 120
85mysql_version_is_at_least "5.01.00.00" \ 121 mysql_version_is_at_least "5.1" \
86&& IUSE="${IUSE} innodb" 122 && IUSE="${IUSE} innodb"
87 123
88mysql_version_is_at_least "5.01.00.00" \ 124 mysql_version_is_at_least "5.1" \
89|| IUSE="${IUSE} berkdb" 125 || IUSE="${IUSE} berkdb"
126
127 mysql_version_is_at_least "5.1.12" \
128 && IUSE="${IUSE} pbxt"
129
130 RDEPEND="${DEPEND} selinux? ( sec-policy/selinux-mysql )"
131
132fi # if [[ "${_MYPVR}" != "${PVR}" ]]
90 133
91EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \ 134EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
92 pkg_postinst pkg_config pkg_postrm 135 pkg_postinst pkg_config pkg_postrm
93 136
94# 137#
95# HELPER FUNCTIONS: 138# HELPER FUNCTIONS:
96# 139#
140
141bitkeeper_fetch() {
142
143 local reposuf
144 if [[ -z "${1}" ]] ; then
145 local tpv
146 tpv=( ${PV//[-._]/ } )
147 reposuf="mysql-${tpv[0]}.${tpv[1]}"
148 else
149 reposuf="${1}"
150 fi
151 einfo "using \"${reposuf}\" repository."
152 local repo_uri="bk://mysql.bkbits.net/${reposuf}"
153 ## -- ebk_store_dir: bitkeeper sources store directory
154 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src"
155 ## -- ebk_fetch_cmd: bitkeeper fetch command
156 # always fetch the latest revision, use -r<revision> if a specified revision is wanted
157 # hint: does not work
158 local ebk_fetch_cmd="sfioball"
159 ## -- ebk_update_cmd: bitkeeper update command
160 local ebk_update_cmd="update"
161
162 #addread "/etc/bitkeeper"
163 addwrite "${ebk_store_dir}"
164
165 if [[ ! -d "${ebk_store_dir}" ]]; then
166 debug-print "${FUNCNAME}: initial checkout. creating bitkeeper directory"
167 mkdir -p "${ebk_store_dir}" || die "${EBK}: can't mkdir ${ebk_store_dir}."
168 fi
169
170 pushd "${ebk_store_dir}" || die "${EBK}: can't chdir to ${ebk_store_dir}"
171
172 local wc_path=${reposuf}
173
174 if [[ ! -d "${wc_path}" ]]; then
175 local options="-r+"
176 # first check out
177 einfo "bitkeeper check out start -->"
178 einfo " repository: ${repo_uri}"
179 ${ebk_fetch_cmd} ${options} "${repo_uri}" ${wc_path} \
180 || die "${EBK}: can't fetch from ${repo_uri}."
181 else
182 if [[ ! -d "${wc_path}/BK" ]]; then
183 popd
184 die "Look like ${wc_path} is not a bitkeeper path."
185 fi
186
187 # update working copy
188 einfo "bitkeeper update start -->"
189 einfo " repository: ${repo_uri}"
190
191 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \
192 || die "BK: can't update from ${repo_uri} to ${wc_path}."
193 fi
194
195 einfo " working copy: ${wc_path}"
196 cd "${wc_path}"
197 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: can't export to ${S}."
198
199 echo
200 popd
201
202}
203
204mysql_disable_test() {
205 local testname="${1}" ; shift
206 local reason="${@}"
207 local mysql_disable_file="${S}/mysql-test/t/disabled.def"
208 echo ${testname} : ${reason} >> "${mysql_disable_file}"
209 ewarn "test \"${testname}\" disabled because: \"${reason}\""
210}
97 211
98# void mysql_init_vars() 212# void mysql_init_vars()
99# 213#
100# Initialize global variables 214# Initialize global variables
101# 2005-11-19 <vivo@gentoo.org> 215# 2005-11-19 <vivo@gentoo.org>
102 216
103mysql_init_vars() { 217mysql_init_vars() {
218 if [[ ${SLOT} == "0" ]] ; then
219 MY_SUFFIX=""
220 else
221 MY_SUFFIX=${MY_SUFFIX:-"-${SLOT}"}
222 fi
104 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"} 223 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR:-"/usr/share/mysql${MY_SUFFIX}"}
105 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"} 224 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql${MY_SUFFIX}"}
106 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"} 225 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql${MY_SUFFIX}"}
107 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"} 226 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql${MY_SUFFIX}"}
108 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"} 227 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql${MY_SUFFIX}"}
109 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"} 228 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql${MY_SUFFIX}"}
110 229
111 if [[ -z "${DATADIR}" ]] ; then 230 if [[ -z "${DATADIR}" ]] ; then
112 DATADIR="" 231 DATADIR=""
113 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then 232 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
114 DATADIR=`"my_print_defaults" mysqld 2>/dev/null \ 233 DATADIR=`"my_print_defaults${MY_SUFFIX}" mysqld 2>/dev/null \
115 | sed -ne '/datadir/s|^--datadir=||p' \ 234 | sed -ne '/datadir/s|^--datadir=||p' \
116 | tail -n1` 235 | tail -n1`
117 if [[ -z "${DATADIR}" ]] ; then 236 if [[ -z "${DATADIR}" ]] ; then
118 if useq "srvdir" ; then
119 DATADIR="${ROOT}/srv/localhost/mysql/datadir"
120 else
121 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \ 237 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
122 | sed -e 's/.*=\s*//'` 238 | sed -e 's/.*=\s*//'`
123 fi
124 fi 239 fi
125 fi 240 fi
126 if [[ -z "${DATADIR}" ]] ; then 241 if [[ -z "${DATADIR}" ]] ; then
127 if useq "srvdir" ; then
128 DATADIR="${ROOT}/srv/localhost/mysql/datadir"
129 else
130 DATADIR="${MY_LOCALSTATEDIR}" 242 DATADIR="${MY_LOCALSTATEDIR}"
131 fi
132 einfo "Using default DATADIR" 243 einfo "Using default DATADIR"
133 fi 244 fi
134 elog "MySQL DATADIR is ${DATADIR}" 245 elog "MySQL DATADIR is ${DATADIR}"
135 246
136 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then 247 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
143 fi 254 fi
144 export PREVIOUS_DATADIR 255 export PREVIOUS_DATADIR
145 fi 256 fi
146 fi 257 fi
147 258
259 MY_SOURCEDIR=${SERVER_URI##*/}
260 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
261
148 export MY_SHAREDSTATEDIR MY_SYSCONFDIR 262 export MY_SUFFIX MY_SHAREDSTATEDIR MY_SYSCONFDIR
149 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 263 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
150 export MY_INCLUDEDIR 264 export MY_INCLUDEDIR DATADIR MY_SOURCEDIR
151 export DATADIR
152} 265}
153 266
154configure_minimal() { 267configure_minimal() {
155 # These are things we exclude from a minimal build, please 268 # These are things we exclude from a minimal build, please
156 # note that the server actually does get built and installed, 269 # note that the server actually does get built and installed,
157 # but we then delete it before packaging. 270 # but we then delete it before packaging.
158 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 271 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication"
159 272
160 for i in ${minimal_exclude_list} ; do 273 for i in ${minimal_exclude_list} ; do
161 myconf="${myconf} --without-${i}" 274 myconf="${myconf} --without-${i}"
162 done 275 done
163 myconf="${myconf} --with-extra-charsets=none" 276 myconf="${myconf} --with-extra-charsets=none"
277 myconf="${myconf} --enable-local-infile"
278
279 if useq "static" ; then
280 myconf="${myconf} --with-client-ldflags=-all-static"
281 myconf="${myconf} --disable-shared"
282 else
283 myconf="${myconf} --enable-shared --enable-static"
284 fi
285
286 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then
287 myconf="${myconf} --with-charset=utf8"
288 myconf="${myconf} --with-collation=utf8_general_ci"
289 else
290 myconf="${myconf} --with-charset=latin1"
291 myconf="${myconf} --with-collation=latin1_swedish_ci"
292 fi
164} 293}
165 294
166configure_common() { 295configure_common() {
167 myconf="${myconf} $(use_with big-tables)" 296 myconf="${myconf} $(use_with big-tables)"
168 myconf="${myconf} --enable-local-infile" 297 myconf="${myconf} --enable-local-infile"
182 311
183 if useq "debug" ; then 312 if useq "debug" ; then
184 myconf="${myconf} --with-debug=full" 313 myconf="${myconf} --with-debug=full"
185 else 314 else
186 myconf="${myconf} --without-debug" 315 myconf="${myconf} --without-debug"
187 mysql_version_is_at_least "4.01.03.00" \ 316 mysql_version_is_at_least "4.1.3" \
188 && useq "cluster" \ 317 && useq "cluster" \
189 && myconf="${myconf} --without-ndb-debug" 318 && myconf="${myconf} --without-ndb-debug"
190 fi 319 fi
191 320
192 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then 321 if mysql_version_is_at_least "4.1" && ! useq "latin1" ; then
193 myconf="${myconf} --with-charset=utf8" 322 myconf="${myconf} --with-charset=utf8"
194 myconf="${myconf} --with-collation=utf8_general_ci" 323 myconf="${myconf} --with-collation=utf8_general_ci"
195 else 324 else
196 myconf="${myconf} --with-charset=latin1" 325 myconf="${myconf} --with-charset=latin1"
197 myconf="${myconf} --with-collation=latin1_swedish_ci" 326 myconf="${myconf} --with-collation=latin1_swedish_ci"
211 myconf="${myconf} $(use_with perl bench)" 340 myconf="${myconf} $(use_with perl bench)"
212 myconf="${myconf} --enable-assembler" 341 myconf="${myconf} --enable-assembler"
213 myconf="${myconf} --with-extra-tools" 342 myconf="${myconf} --with-extra-tools"
214 myconf="${myconf} --with-innodb" 343 myconf="${myconf} --with-innodb"
215 myconf="${myconf} --without-readline" 344 myconf="${myconf} --without-readline"
216 mysql_version_is_at_least "5.00.00.00" || myconf="${myconf} $(use_with raid)" 345 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
217 346
218 if useq "ssl" ; then 347 if useq "ssl" ; then
219 # --with-vio is not needed anymore, it's on by default and 348 # --with-vio is not needed anymore, it's on by default and
220 # has been removed from configure 349 # has been removed from configure
221 mysql_version_is_at_least "5.00.04.00" || myconf="${myconf} --with-vio" 350 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
222 if mysql_version_is_at_least "5.00.06.00" ; then 351 if mysql_version_is_at_least "5.0.6" ; then
223 # myconf="${myconf} --with-yassl" 352 # myconf="${myconf} --with-yassl"
224 myconf="${myconf} --with-openssl" 353 myconf="${myconf} --with-openssl"
225 else 354 else
226 myconf="${myconf} --with-openssl" 355 myconf="${myconf} --with-openssl"
227 fi 356 fi
241 else 370 else
242 myconf="${myconf} --without-berkeley-db" 371 myconf="${myconf} --without-berkeley-db"
243 fi 372 fi
244 fi 373 fi
245 374
246 if mysql_version_is_at_least "4.01.03.00" ; then 375 if mysql_version_is_at_least "4.1.3" ; then
247 myconf="${myconf} --with-geometry" 376 myconf="${myconf} --with-geometry"
248 myconf="${myconf} $(use_with cluster ndbcluster)" 377 myconf="${myconf} $(use_with cluster ndbcluster)"
249 fi 378 fi
250 379
251 if mysql_version_is_at_least "4.01.03.00" && useq "extraengine" ; then 380 if mysql_version_is_at_least "4.1.3" && useq "extraengine" ; then
252 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 381 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
253 myconf="${myconf} --with-archive-storage-engine" 382 myconf="${myconf} --with-archive-storage-engine"
254 383
255 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html 384 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
256 myconf="${myconf} --with-csv-storage-engine" 385 myconf="${myconf} --with-csv-storage-engine"
259 myconf="${myconf} --with-blackhole-storage-engine" 388 myconf="${myconf} --with-blackhole-storage-engine"
260 389
261 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html 390 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html
262 # http://dev.mysql.com/doc/mysql/en/federated-description.html 391 # http://dev.mysql.com/doc/mysql/en/federated-description.html
263 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html 392 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
264 if mysql_version_is_at_least "5.00.03.00" ; then 393 if mysql_version_is_at_least "5.0.3" ; then
265 elog "Before using the Federated storage engine, please be sure to read" 394 elog "Before using the Federated storage engine, please be sure to read"
266 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html" 395 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
267 myconf="${myconf} --with-federated-storage-engine" 396 myconf="${myconf} --with-federated-storage-engine"
268 fi 397 fi
269 fi 398 fi
270 399
271 mysql_version_is_at_least "5.00.18.00" \ 400 mysql_version_is_at_least "5.0.18" \
272 && useq "max-idx-128" \ 401 && useq "max-idx-128" \
273 && myconf="${myconf} --with-max-indexes=128" 402 && myconf="${myconf} --with-max-indexes=128"
274} 403}
275 404
276configure_51() { 405configure_51() {
289 # 5.1 introduces a new way to manage storage engines (plugins) 418 # 5.1 introduces a new way to manage storage engines (plugins)
290 # like configuration=none 419 # like configuration=none
291 local plugins="csv,myisam,myisammrg,heap" 420 local plugins="csv,myisam,myisammrg,heap"
292 if useq "extraengine" ; then 421 if useq "extraengine" ; then
293 # like configuration=max-no-ndb, archive and example removed in 5.1.11 422 # like configuration=max-no-ndb, archive and example removed in 5.1.11
294 plugins="${plugins},archive,blackhole,example,federated,ftexample,partition" 423 plugins="${plugins},archive,blackhole,example,federated,partition"
295 424
296 elog "Before using the Federated storage engine, please be sure to read" 425 elog "Before using the Federated storage engine, please be sure to read"
297 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 426 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
298 fi 427 fi
299 428
308 fi 437 fi
309 438
310 myconf="${myconf} --with-plugins=${plugins}" 439 myconf="${myconf} --with-plugins=${plugins}"
311} 440}
312 441
442pbxt_src_compile() {
443 mysql_init_vars
444
445 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
446
447 einfo "Reconfiguring dir '${PWD}'"
448 AT_GNUCONF_UPDATE="yes" eautoreconf
449
450 local myconf
451 myconf="${myconf} --with-mysql=${S}"
452 mkdir -p ${T}/lib
453 myconf="${myconf} --libdir=${D}/${MY_LIBDIR}"
454 useq "debug" && myconf="${myconf} --with-debug=full"
455 # TODO is safe/needed to use econf here ?
456 ./configure ${myconf} || die "problem configuring pbxt storage engine"
457 # TODO is safe/needed to use emake here ?
458 make || die "problem making pbxt storage engine (${myconf})"
459
460 popd
461 # TODO: modify test suite
462}
463
464pbxt_src_install() {
465 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
466 make install || die "failed pbxt install"
467 popd
468}
469
313# 470#
314# EBUILD FUNCTIONS 471# EBUILD FUNCTIONS
315# 472#
316 473
317mysql_pkg_setup() { 474mysql_pkg_setup() {
318 enewgroup mysql 60 || die "problem adding 'mysql' group" 475 enewgroup mysql 60 || die "problem adding 'mysql' group"
319 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 476 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
320
321 if mysql_version_is_at_least "5.01.12.00" && useq "innodb" ; then
322 eerror "InnoDB now uses cmake to build, this is a TODO item, will be fixed shortly!"
323 die "InnoDB now uses cmake to build, this is a TODO item, will be fixed shortly!"
324 fi
325 477
326 # Check for USE flag problems in pkg_setup 478 # Check for USE flag problems in pkg_setup
327 if useq "static" && useq "ssl" ; then 479 if useq "static" && useq "ssl" ; then
328 eerror "MySQL does not support being built statically with SSL support enabled!" 480 eerror "MySQL does not support being built statically with SSL support enabled!"
329 die "MySQL does not support being built statically with SSL support enabled!" 481 die "MySQL does not support being built statically with SSL support enabled!"
330 fi 482 fi
331 483
332 if ! mysql_version_is_at_least "5.00.00.00" \ 484 if ! mysql_version_is_at_least "5.0" \
333 && useq "raid" \ 485 && useq "raid" \
334 && useq "static" ; then 486 && useq "static" ; then
335 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically" 487 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
336 eerror "with RAID support enabled." 488 eerror "with RAID support enabled."
337 die "USE flags 'raid' and 'static' conflict!" 489 die "USE flags 'raid' and 'static' conflict!"
338 fi 490 fi
339 491
340 if mysql_version_is_at_least "4.01.03.00" \ 492 if mysql_version_is_at_least "4.1.3" \
341 && ( useq "cluster" || useq "extraengine" ) \ 493 && ( useq "cluster" || useq "extraengine" ) \
342 && useq "minimal" ; then 494 && useq "minimal" ; then
343 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 495 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
344 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 496 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
345 fi 497 fi
346 498
347 mysql_check_version_range "4.00.00.00 to 5.00.99.99" \ 499 mysql_check_version_range "4.0 to 5.0.99.99" \
348 && useq "berkdb" \ 500 && useq "berkdb" \
349 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 501 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
350} 502}
351 503
352mysql_src_unpack() { 504mysql_src_unpack() {
353 # Initialize the proper variables first 505 # Initialize the proper variables first
354 mysql_init_vars 506 mysql_init_vars
355 507
356 unpack ${A} 508 unpack ${A}
357 509 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then
358 mv -f "${WORKDIR}/${MY_P}${MYSQL_RERELEASE}" "${S}" 510 if mysql_check_version_range "5.1 to 5.1.99" ; then
511 bitkeeper_fetch "mysql-5.1-ndb"
512 elif mysql_check_version_range "5.2 to 5.2.99" ; then
513 bitkeeper_fetch "mysql-5.2-falcon"
514 else
515 bitkeeper_fetch
516 fi
359 cd "${S}" 517 cd "${S}"
518 einfo "running upstream autorun on bk sources"
519 BUILD/autorun.sh
520 else
521 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
522 cd "${S}"
523 fi
360 524
361 # Apply the patches for this MySQL version 525 # Apply the patches for this MySQL version
362 if [[ -d "${WORKDIR}/${MY_FIXED_PV}" ]] ; then 526 EPATCH_SUFFIX="patch"
363 EPATCH_SOURCE="${WORKDIR}/${MY_FIXED_PV}" EPATCH_SUFFIX="patch" epatch 527 mkdir -p "${EPATCH_SOURCE}" || die "unable to create epatch directory"
364 fi 528 mysql_mv_patches
529 epatch || die "failed to apply all patches"
365 530
366 # Additional checks, remove bundled zlib 531 # Additional checks, remove bundled zlib
367 rm -f "${S}/zlib/"*.[ch] 532 rm -f "${S}/zlib/"*.[ch]
368 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 533 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
369 rm -f "scripts/mysqlbug" 534 rm -f "scripts/mysqlbug"
370 535
371 # Make charsets install in the right place 536 # Make charsets install in the right place
372 find . -name 'Makefile.am' \ 537 find . -name 'Makefile.am' \
373 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 538 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
374 539
375 # Manage mysqlmanager
376 mysql_version_is_at_least "5.00.15.00" \
377 && sed -i -e "s!@GENTOO_EXT@!!g" \
378 -e "s!@GENTOO_SOCK_PATH@!var/run/mysqld!g" \
379 "${S}/server-tools/instance-manager/Makefile.am"
380
381 if mysql_version_is_at_least "4.01.00.00" ; then 540 if mysql_version_is_at_least "4.1" ; then
382 # Remove what needs to be recreated, so we're sure it's actually done 541 # Remove what needs to be recreated, so we're sure it's actually done
383 find . -name Makefile \ 542 find . -name Makefile \
384 -o -name Makefile.in \ 543 -o -name Makefile.in \
385 -o -name configure \ 544 -o -name configure \
386 -exec rm -f {} \; 545 -exec rm -f {} \;
387 rm -f "ltmain.sh" 546 rm -f "ltmain.sh"
388 rm -f "scripts/mysqlbug" 547 rm -f "scripts/mysqlbug"
389 fi 548 fi
390 549
391 local rebuilddirlist bdbdir d 550 local rebuilddirlist d
392 551
393 if mysql_version_is_at_least "5.01.12.00" ; then 552 if mysql_version_is_at_least "5.1.12" ; then
394 # TODO: innodb is using cmake now?
395 rebuilddirlist="." 553 rebuilddirlist="."
396 bdbdir='' 554 # TODO IMPO! Check this with a cmake expert
555 useq "innodb" \
556 && cmake \
557 -DCMAKE_C_COMPILER=$(which $(tc-getCC)) \
558 -DCMAKE_CXX_COMPILER=$(which $(tc-getCC)) \
559 "storage/innobase"
397 else 560 else
398 rebuilddirlist=". innobase" 561 rebuilddirlist=". innobase"
399 bdbdir='bdb/dist'
400 fi 562 fi
401 563
402 for d in ${rebuilddirlist} ; do 564 for d in ${rebuilddirlist} ; do
403 einfo "Reconfiguring dir '${d}'" 565 einfo "Reconfiguring dir '${d}'"
404 pushd "${d}" &>/dev/null 566 pushd "${d}" &>/dev/null
405 AT_GNUCONF_UPDATE="yes" eautoreconf 567 AT_GNUCONF_UPDATE="yes" eautoreconf
406 popd &>/dev/null 568 popd &>/dev/null
407 done 569 done
408 570
409 if mysql_check_version_range "4.01.00.00 to 5.00.99.99" \ 571 if mysql_check_version_range "4.1 to 5.0.99.99" \
410 && useq "berkdb" ; then 572 && useq "berkdb" ; then
411 [[ -w "${bdbdir}/ltmain.sh" ]] && cp -f "ltmain.sh" "${bdbdir}/ltmain.sh" 573 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
412 pushd "${bdbdir}" \ 574 pushd "bdb/dist" \
413 && sh s_all \ 575 && sh s_all \
414 || die "Failed bdb reconfigure" \ 576 || die "Failed bdb reconfigure" \
415 &>/dev/null 577 &>/dev/null
416 popd &>/dev/null 578 popd &>/dev/null
417 fi 579 fi
426 588
427 if useq "minimal" ; then 589 if useq "minimal" ; then
428 configure_minimal 590 configure_minimal
429 else 591 else
430 configure_common 592 configure_common
431 if mysql_version_is_at_least "5.01.10.00" ; then 593 if mysql_version_is_at_least "5.1.10" ; then
432 configure_51 594 configure_51
433 else 595 else
434 configure_40_41_50 596 configure_40_41_50
435 fi 597 fi
436 fi 598 fi
439 filter-flags "-O" "-O[01]" 601 filter-flags "-O" "-O[01]"
440 602
441 # glib-2.3.2_pre fix, bug #16496 603 # glib-2.3.2_pre fix, bug #16496
442 append-flags "-DHAVE_ERRNO_AS_DEFINE=1" 604 append-flags "-DHAVE_ERRNO_AS_DEFINE=1"
443 605
444 append-flags "-fno-exceptions -fno-strict-aliasing" 606 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing"
445 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti" 607 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti"
446 mysql_version_is_at_least "5.00.00.00" \ 608 mysql_version_is_at_least "5.0" \
447 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 609 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
448 export CXXFLAGS 610 export CXXFLAGS
449 611
450 econf \ 612 econf \
613 --program-suffix="${MY_SUFFIX}" \
451 --libexecdir="/usr/sbin" \ 614 --libexecdir="/usr/sbin" \
452 --sysconfdir="${MY_SYSCONFDIR}" \ 615 --sysconfdir="${MY_SYSCONFDIR}" \
453 --localstatedir="${MY_LOCALSTATEDIR}" \ 616 --localstatedir="${MY_LOCALSTATEDIR}" \
454 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 617 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
455 --libdir="${MY_LIBDIR}" \ 618 --libdir="${MY_LIBDIR}" \
465 find . -type f -name Makefile -print0 \ 628 find . -type f -name Makefile -print0 \
466 | xargs -0 -n100 sed -i \ 629 | xargs -0 -n100 sed -i \
467 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 630 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
468 631
469 emake || die "emake failed" 632 emake || die "emake failed"
633
634 mysql_version_is_at_least "5.1.1" && useq "pbxt" && pbxt_src_compile
470} 635}
471 636
472mysql_src_install() { 637mysql_src_install() {
473 # Make sure the vars are correctly initialized 638 # Make sure the vars are correctly initialized
474 mysql_init_vars 639 mysql_init_vars
475 640
476 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed" 641 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die
642
643 mysql_version_is_at_least "5.1.12" && useq "pbxt" && pbxt_src_install
477 644
478 insinto "${MY_INCLUDEDIR}" 645 insinto "${MY_INCLUDEDIR}"
479 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h 646 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
480 647
481 # Convenience links 648 # Convenience links
482 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze" 649 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlanalyze${MY_SUFFIX}"
483 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair" 650 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlrepair${MY_SUFFIX}"
484 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize" 651 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqloptimize${MY_SUFFIX}"
485 652
486 # Various junk (my-*.cnf moved elsewhere) 653 # Various junk (my-*.cnf moved elsewhere)
487 rm -Rf "${D}/usr/share/info" 654 rm -Rf "${D}/usr/share/info"
488 for removeme in "mysql-log-rotate" mysql.server* \ 655 for removeme in "mysql-log-rotate" mysql.server* \
489 binary-configure* my-*.cnf mi_test_all* 656 binary-configure* my-*.cnf mi_test_all*
490 do 657 do
491 rm -f "${D}"/usr/share/mysql/${removeme} 658 rm -f "${D}"/usr/share/mysql/${removeme}
492 done 659 done
493 660
661 # TODO change at Makefile-am level
662 if [[ ${PN} == "mysql-slotted" ]] ; then
663 for moveme in "mysql_fix_privilege_tables.sql" \
664 "fill_help_tables.sql" "ndb-config-2-node.ini"
665 do
666 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
667 done
668 fi
669
494 # Clean up stuff for a minimal build 670 # clean up stuff for a minimal build
495 if useq "minimal" ; then 671 if useq "minimal" ; then
496 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 672 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
497 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 673 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
498 rm -f "${D}/usr/sbin/mysqld" 674 rm -f "${D}/usr/sbin/mysqld"
499 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 675 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
500 fi 676 fi
501 677
678 if [[ ${PN} == "mysql-slotted" ]] ; then
679 local notcatched=$(ls "${D}/usr/share/mysql"/*)
680 if [[ -n "${notcatched}" ]] ; then
681 ewarn "QA notice"
682 ewarn "${notcatched} files in /usr/share/mysql"
683 ewarn "bug mysql-herd to manage them"
684 fi
685 rm -Rf "${D}/usr/share/mysql"
686 fi
687
502 # Configuration stuff 688 # Configuration stuff
503 if mysql_version_is_at_least "4.01.00.00" ; then 689 if mysql_version_is_at_least "4.1" ; then
504 mysql_mycnf_version="4.1" 690 mysql_mycnf_version="4.1"
505 else 691 else
506 mysql_mycnf_version="4.0" 692 mysql_mycnf_version="4.0"
507 fi 693 fi
508 insinto "${MY_SYSCONFDIR}" 694 insinto "${MY_SYSCONFDIR}"
509 doins "scripts/mysqlaccess.conf" 695 doins scripts/mysqlaccess.conf
696 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \
510 sed -e "s!@DATADIR@!${DATADIR}!g" \ 697 -e "s!@DATADIR@!${DATADIR}!g" \
511 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 698 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
512 > "${TMPDIR}/my.cnf.ok" 699 > "${TMPDIR}/my.cnf.ok"
513 if mysql_version_is_at_least "4.01.00.00" && useq "latin1" ; then 700 if mysql_version_is_at_least "4.1" && useq "latin1" ; then
514 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 701 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
515 fi 702 fi
516 newins "${TMPDIR}/my.cnf.ok" my.cnf 703 newins "${TMPDIR}/my.cnf.ok" my.cnf
517
518 insinto "/etc/conf.d"
519 newins "${FILESDIR}/mysql.conf.d" "mysql"
520 mysql_version_is_at_least "5.00.11.00" \
521 && newins "${FILESDIR}/mysqlmanager.conf.d" "mysqlmanager"
522 704
523 # Minimal builds don't have the MySQL server 705 # Minimal builds don't have the MySQL server
524 if ! useq "minimal" ; then 706 if ! useq "minimal" ; then
525 exeinto "/etc/init.d"
526 newexe "${FILESDIR}/mysql.rc6" "mysql"
527 mysql_version_is_at_least "5.00.11.00" \
528 && newexe "${FILESDIR}/mysqlmanager.rc6" "mysqlmanager"
529
530 insinto "/etc/logrotate.d"
531 newins "${FILESDIR}/logrotate.mysql" "mysql"
532
533 # Empty directories ... 707 # Empty directories ...
534 diropts "-m0750" 708 diropts "-m0750"
535 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 709 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
536 dodir "${DATADIR}" 710 dodir "${DATADIR}"
537 keepdir "${DATADIR}" 711 keepdir "${DATADIR}"
564 for script in scripts/mysql* ; do 738 for script in scripts/mysql* ; do
565 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 739 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
566 done 740 done
567 fi 741 fi
568 742
569 ROOT="${D}" mysql_lib_symlinks 743 if [[ ${PN} == "mysql-slotted" ]] ; then
744 # MOVED HERE DUE TO BUG #121445
745 # create a list of files, to be used
746 # by external utilities
747 mkdir -p "${D}/var/lib/eselect/mysql/"
748 local filelist="${D}/var/lib/eselect/mysql/mysql${MY_SUFFIX}.filelist"
749 pushd "${D}/" &>/dev/null
750 find usr/bin/ usr/sbin/ \
751 -type f -name "*${MY_SUFFIX}*" \
752 -and -not -name "mysql_config${MY_SUFFIX}" \
753 > "${filelist}"
754 find usr/share/man \
755 -type f -name "*${MY_SUFFIX}*" \
756 | sed -e 's/$/.gz/' \
757 >> "${filelist}"
758 echo "${MY_SYSCONFDIR#"/"}" >> "${filelist}"
759 echo "${MY_LIBDIR#"/"}" >> "${filelist}"
760 echo "${MY_SHAREDSTATEDIR#"/"}" >> "${filelist}"
761 popd &>/dev/null
762 fi
570} 763}
571 764
572mysql_pkg_preinst() { 765mysql_pkg_preinst() {
573 enewgroup mysql 60 || die "problem adding 'mysql' group" 766 enewgroup mysql 60 || die "problem adding 'mysql' group"
574 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 767 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
585 # Secure the logfiles 778 # Secure the logfiles
586 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err} 779 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
587 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql* 780 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
588 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql* 781 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
589 782
783 # Minimal builds don't have the MySQL server
590 if ! useq "minimal" ; then 784 if ! useq "minimal" ; then
591 # Your friendly public service announcement ... 785 docinto "support-files"
592 einfo 786 for script in \
593 elog "You might want to run:" 787 support-files/my-*.cnf \
594 elog "\"emerge --config =${CATEGORY}/${PF}\"" 788 support-files/magic \
595 elog "if this is a new install." 789 support-files/ndb-config-2-node.ini
596 einfo 790 do
597 mysql_version_is_at_least "5.01.00.00" \ 791 dodoc "${script}"
598 || elog "InnoDB is *not* optional as of MySQL-4.0.24, at the request of upstream." 792 done
793
794 docinto "scripts"
795 for script in scripts/mysql* ; do
796 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
797 done
599 fi 798 fi
799
800 einfo "you may want to read slotting upgrade documents in the overlay"
801 if useq "pbxt" && mysql_version_is_at_least "5.1" ; then
802 # TODO tell it better ;-)
803 einfo "mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
804 einfo "CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
805 einfo "if, after that you cannot start the mysql server"
806 einfo "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
807 einfo "use the mysql upgrade script to restore the table"
808 einfo " or "
809 einfo "CREATE TABLE IF NOT EXISTS plugin ("
810 einfo " name char(64) binary DEFAULT '' NOT NULL,"
811 einfo " dl char(128) DEFAULT '' NOT NULL,"
812 einfo " PRIMARY KEY (name)"
813 einfo ") CHARACTER SET utf8 COLLATE utf8_bin;"
814 fi
600 mysql_check_version_range "4.00.00.00 to 5.00.99.99" \ 815 mysql_check_version_range "4.0 to 5.0.99.99" \
601 && useq "berkdb" \ 816 && useq "berkdb" \
602 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 817 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
603} 818}
604 819
605mysql_pkg_config() { 820mysql_pkg_config() {
606 # Make sure the vars are correctly initialized 821 # Make sure the vars are correctly initialized
607 mysql_init_vars 822 mysql_init_vars
608 823
609 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR" 824 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR"
610 825
611 if built_with_use dev-db/mysql minimal ; then 826 if built_with_use ${CATEGORY}/${PN} minimal ; then
612 die "Minimal builds do NOT include the MySQL server" 827 die "Minimal builds do NOT include the MySQL server"
613 fi 828 fi
614 829
615 local pwd1="a" 830 local pwd1="a"
616 local pwd2="b" 831 local pwd2="b"
652 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \ 867 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \
653 || die "MySQL databases not installed" 868 || die "MySQL databases not installed"
654 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null 869 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null
655 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null 870 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null
656 871
657 if mysql_version_is_at_least "4.01.03.00" ; then 872 if mysql_version_is_at_least "4.1.3" ; then
658 options="--skip-ndbcluster" 873 options="--skip-ndbcluster"
659 874
660 # Filling timezones, see 875 # Filling timezones, see
661 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html 876 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
662 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null 877 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null
711 wait %1 926 wait %1
712 einfo "Done" 927 einfo "Done"
713} 928}
714 929
715mysql_pkg_postrm() { 930mysql_pkg_postrm() {
931 if [[ ${PN} == "mysql-slotted" ]] ; then
716 mysql_lib_symlinks 932 mysql_lib_symlinks
933 fi
717} 934}

Legend:
Removed from v.1.43  
changed lines
  Added in v.1.56

  ViewVC Help
Powered by ViewVC 1.1.20